package com.fp.persistence.pgeneral.proc;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEPROCESS*/
@Entity(name="TgeneProcess")
@Table(name="TGENEPROCESS")
public class TgeneProcess extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneProcess
*/
@EmbeddedId
private TgeneProcessKey pk;
@Column(name="DESCRIPTION", nullable=false)

/**
* Descrición generral de las actividades que realiza el comando
*/
private String description;

@Column(name="SHORTDESC", nullable=true)

/**
* null
*/
private String shortdesc;

/**Contructor por defecto*/
public TgeneProcess(){
}
/**Contructor de TgeneProcess
@param pPk Clave Primaria del entity
@param pDescription Descrición generral de las actividades que realiza el comando
*/
public TgeneProcess(TgeneProcessKey pPk,String pDescription){
 this();
 pk=pPk;
 description=pDescription;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneProcess
*/
public static TgeneProcess find(EntityManager pEntityManager,TgeneProcessKey pKey) throws Exception{
    TgeneProcess obj = pEntityManager.find(TgeneProcess.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneProcess
@return El objeto que referencia a la Clave primaria de TgeneProcess
*/
public TgeneProcessKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneProcess
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneProcess
*/
public void setPk(TgeneProcessKey pPk){
  pk=pPk;
}
/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

/**Obtiene el valor de shortdesc
@return valor de shortdesc*/
public String getShortdesc(){
  return shortdesc;
}
/**Fija el valor de shortdesc
@param pShortdesc nuevo Valor de shortdesc*/
public void setShortdesc(String pShortdesc){
  shortdesc=pShortdesc;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneProcess))return false;
    TgeneProcess that = (TgeneProcess) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneProcess
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneProcess
*/
public Object createInstance(){
 TgeneProcess instance=new TgeneProcess();	
 instance.setPk(new TgeneProcessKey());
 return instance;
}
/**Clona la entidad TgeneProcess
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneProcess p=(TgeneProcess)this.clone();
  p.setPk((TgeneProcessKey)this.pk.cloneMe());
  return p;
}
}
